/**
 * vim: set ts=4 :
 * =============================================================================
 * SourceMod (C)2004-2008 AlliedModders LLC.  All rights reserved.
 * =============================================================================
 *
 * This file is part of the SourceMod/SourcePawn SDK.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3.0, as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * As a special exception, AlliedModders LLC gives you permission to link the
 * code of this program (as well as its derivative works) to "Half-Life 2," the
 * "Source Engine," the "SourcePawn JIT," and any Game MODs that run on software
 * by the Valve Corporation.  You must obey the GNU General Public License in
 * all respects for all other code used.  Additionally, AlliedModders LLC grants
 * this exception to all derivative works.  AlliedModders LLC defines further
 * exceptions, found in LICENSE.txt (as of this writing, version JULY-31-2007),
 * or <http://www.sourcemod.net/license.php>.
 *
 * Version: $Id: structs.inc 245 2008-07-28 07:14:33Z pred $
 */

#if defined _structs_included
 #endinput
#endif
#define _structs_included


native GetStructInt(Handle:strct, const String:member[]);

native bool:SetStructInt(Handle:strct, const String:member[], value);

native Float:GetStructFloat(Handle:strct, const String:member[]);

native bool:SetStructFloat(Handle:strct, const String:member[], Float:value);

native bool:GetStructVector(Handle:strct, const String:member[], Float:vec[3]);

native bool:SetStructVector(Handle:strct, const String:member[], Float:vec[3]);

native bool:GetStructString(Handle:strct, const String:member[], const String:value[], maxlen);

native bool:SetStructString(Handle:strct, const String:member[], String:value[]);

native GetStructEnt(Handle:strct, const String:member[]);

native bool:SetStructEnt(Handle:strct, const String:member[], entity);

native Handle:GetTestStruct();

native DumpTestStruct();

native Handle:GetWeaponStruct(const String:weapon[]);

/**
 * Do not edit below this line!
 */
public Extension:__ext_struct = 
{
	name = "Struct Abstraction Extension",
	file = "structs.ext",
	autoload = 1,
#if defined REQUIRE_EXTENSIONS
	required = 1,
#else
	required = 0,
#endif
};
