#include <sourcemod>
#include "structs.inc"

public Plugin:myinfo = 
{
	name = "Struct Abstraction Test",
	author = "pRED*",
	description = "",
	version = "1.0",
	url = "http://www.sourcemod.net/"
};

public OnPluginStart()
{
	RegServerCmd("sm_structerase", Command_Erase);
	RegServerCmd("sm_structfill", Command_Fill);
	
	RegServerCmd("sm_getweaponstruct", Command_GetWeapon);
	
	RegServerCmd("sm_getstructint", Command_GetInt);
	RegServerCmd("sm_setstructint", Command_SetInt);
	
	RegServerCmd("sm_getstructfloat", Command_GetFloat);
	RegServerCmd("sm_setstructfloat", Command_SetFloat);
	
	RegServerCmd("sm_hi", Command_Two);
}

public Action:Command_Erase(args)
{
	new Handle:strct = GetTestStruct();	
	
	SetStructInt(strct, "one", 0);
	SetStructInt(strct, "two", 0);
	SetStructInt(strct, "three", 0);
	SetStructInt(strct, "four", 0);
	SetStructInt(strct, "five", 0);
	SetStructInt(strct, "six", 0);
	SetStructFloat(strct, "seven", 0.0);
	SetStructFloat(strct, "eight", 0.0);
	SetStructVector(strct, "nine", Float:{0.0, 0.0, 0.0});
	SetStructVector(strct, "ten", Float:{0.0, 0.0, 0.0});
	SetStructString(strct, "eleven", "");
	SetStructString(strct, "twelve", "");
	SetStructEnt(strct, "thirteen", 0);
	SetStructEnt(strct, "fourteen", 0);	
	
	DumpTestStruct();
	
	CloseHandle(strct);
	
	return Plugin_Handled;
}

public Action:Command_Fill(args)
{
	new Handle:strct = GetTestStruct();	
	
	SetStructInt(strct, "one", 1);
	SetStructInt(strct, "two", 2);
	SetStructInt(strct, "three", 3);
	SetStructInt(strct, "four", 4);
	SetStructInt(strct, "five", 5);
	SetStructInt(strct, "six", 6);
	SetStructFloat(strct, "seven", 7.1);
	SetStructFloat(strct, "eight", 8.2);
	SetStructVector(strct, "nine", Float:{0.1, 10.0, 3.0});
	SetStructVector(strct, "ten", Float:{0.0, 6.7, 5.0});
	SetStructString(strct, "eleven", "Hello");
	SetStructString(strct, "twelve", "Thar");
	SetStructEnt(strct, "thirteen", 1);
	SetStructEnt(strct, "fourteen", 1);	
	
	DumpTestStruct();
	
	CloseHandle(strct);
	
	return Plugin_Handled;
}

public Action:Command_GetWeapon(args)
{
	if (args != 2)
	{
		ReplyToCommand(0, "[SM] Usage: sm_getstructstring <struct> <string>");
		return Plugin_Handled;
	}

	decl String:arg1[32], String:arg2[32], String:value[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));

	new Handle:strct = GetWeaponStruct(arg1);
	GetStructString(strct, arg2, value, sizeof(value));

	LogMessage("Value of %s: %s", arg2, value);

	CloseHandle(strct);

	return Plugin_Handled;
}

public Action:Command_GetInt(args)
{
	if (args != 2)
	{
		ReplyToCommand(0, "[SM] Usage: sm_getstructint <struct> <string>");
		return Plugin_Handled;
	}

	decl String:arg1[32], String:arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));

	new Handle:strct = GetWeaponStruct(arg1);
	new value = GetStructInt(strct, arg2);

	LogMessage("Value of %s: %i", arg2, value);

	CloseHandle(strct);

	return Plugin_Handled;
}

public Action:Command_SetInt(args)
{
	if (args != 3)
	{
		ReplyToCommand(0, "[SM] Usage: sm_setstructint <struct> <string> <value>");
		return Plugin_Handled;
	}

	decl String:arg1[32], String:arg2[32], String:value[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	GetCmdArg(3, value, sizeof(value));

	new Handle:strct = GetWeaponStruct(arg1);
	SetStructInt(strct, arg2, StringToInt(value));


	CloseHandle(strct);

	return Plugin_Handled;
}

public Action:Command_Two(args)
{
	new Handle:strct = GetWeaponStruct("tf_weapon_scattergun");
	LogMessage("%i", GetStructInt(Handle:strct, "bParsedScript"));
}


public Action:Command_GetFloat(args)
{
	if (args != 2)
	{
		ReplyToCommand(0, "[SM] Usage: sm_getstructint <struct> <string>");
		return Plugin_Handled;
	}

	decl String:arg1[32], String:arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));

	new Handle:strct = GetWeaponStruct(arg1);
	new Float:value = GetStructFloat(strct, arg2);

	LogMessage("Value of %s: %f", arg2, value);

	CloseHandle(strct);

	return Plugin_Handled;
}

public Action:Command_SetFloat(args)
{
	if (args != 3)
	{
		ReplyToCommand(0, "[SM] Usage: sm_setstructint <struct> <string> <value>");
		return Plugin_Handled;
	}

	decl String:arg1[32], String:arg2[32], String:value[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	GetCmdArg(3, value, sizeof(value));

	new Handle:strct = GetWeaponStruct(arg1);
	SetStructFloat(strct, arg2, StringToFloat(value));


	CloseHandle(strct);

	return Plugin_Handled;
}
